<id>
StopForumSpam Mod for YaBB 2.6.1
</id>

<version>
0.8
</version>

<mod info>
Description
-----------
This Mod will allow you to check the StopForumSpam.com database for Usernames, Email Addresses and IP Addresses on registration, guest posting, broadcast message, alert moderator and send topic.
You can also allow Administrators to submit details to the database when spammers get through who haven't already been submitted (you will need an API Key from their website for the submit feature to work).

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload StopForumSpam.pm and StopForumSpam.lng to their relevant directories in ASCII mode.
4) Upload sfs.png to yabbfiles/ModImages in binary mode.
5) Go to Admin Center -> Antispam Settings -> StopForumSpam to configure the settings.

Files to edit
-------------
AdminIndex.pl
Admin/Admin.pm
Admin/AdminSubList.pm
Admin/ModList.pm
Admin/ModuleChecker.pm
Admin/NewSettings.pm
Admin/RegistrationLog.pm
Admin/Settings_Antispam.pm
Languages/English/Admin.lng
Languages/English/Error.lng
Languages/English/Register.lng
Sources/BoardIndex.pm
Sources/Post.pm
Sources/Profile.pm
Sources/Register.pm
Sources/SendTopic.pm
Sources/SubList.pm
Templates/default/BoardIndex.template

Version History
---------------
V0.1 - First release - 8th September 2011
V0.1.1 - Optimized to only send one request - 13th September 2011
V0.1.2 - Fixed small syntax error - 16th October 2011
V0.2 - Added Admin options to choose which details to check against the database - 20th October 2011
V0.2.1 - Added error message if unable to connect to the SopForumSpam database and moved code below other checks on registration page - 26th October 2011
V0.2.2 - Added a timeout and Admin option to choose how registration should behave if the StopForumSpam database is unavailable and added a custom URL option to redirect spammers to another page/website - 31st October 2011
V0.3 - Added to the Module Check in Admin Center - 1st November 2011
V0.3.1 - Added module checks to the Register page so there will be no spam checks or errors if the required modules are not installed, and added module checks to the settings page so that the settings cannot be enabled if the required modules are not installed - 2nd November 2011
V0.4 - Added Auto-banning for IP Addresses and Email Addresses - 7th November 2011
V0.5 - Added ability for Administrators to submit spam to the StopForumSpam database from user profiles and the registration log, added option to block IPs on server level and moved code to a separate file - 16th November 2011
V0.5.1 - Fixed bug with auto-adding email addresses and added StopForumSpam Statistics to Admin Center and Board Index - 24th November 2011
V0.5.2 - Tidied up Statistics code - 24th November 2011
V0.6 - Added StopForumSpam registration log and added checks to guest posting, broadcast message, alert moderator and send topic - 27th November 2011
V0.7 - Converted to 2.6.0 by Dandello - July 4th, 2014
V0.8 - Converted to 2.6.1 by Dandello - Sept 5th, 2014
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
    @boardmod_mods = (
</search for>

<add before>
    if ($sfs_log) {
        splice(@forum_stats,6,0,"stopforumspam_log|$admintxt{'a8_sub6'}|$admintxt{'a8_label6'}|")
    }

</add before>

<edit file>
Admin/Admin.pm
</edit file>

<search for>
    </table>
</div>~;

    $yytitle     = $admintxt{'28'};
    $action_area = 'stats';
    AdminTemplate();
    return;
}
</search for>

<add before>
~;
     if ($check_sfs_username || $check_sfs_ip || $check_sfs_email || ($sfs_submit && $sfs_api_key)) {
         if (-e "$vardir/sfs_stats.txt") { require "$vardir/sfs_stats.txt"; }
         LoadLanguage('StopForumSpam');
         $sfs_blocked ||= 0;
         $sfs_submitted ||= 0;
         $yymain .= qq~<tr>
       <td class="catbg">
        <i>$sfs_txt{'stopforumspam'}</i>
      </td>
     </tr><tr>
       <td class="windowbg2">~;
         if ($check_sfs_username || $check_sfs_ip || $check_sfs_email) {
             $yymain .= qq~
        <div style="float: left; clear: left; width: 35%; text-align: left; padding-top: 2px; padding-bottom: 2px;">$sfs_txt{'total_blocked'}</div>
        <div style="float: left; width: 10%; text-align: right; padding-top: 2px; padding-bottom: 2px;">$sfs_blocked</div>~;
        }
         if ($sfs_submit && $sfs_api_key) {
             $yymain .= qq~
        <div style="float: left; clear: left; width: 35%; text-align: left; padding-top: 2px; padding-bottom: 2px;">$sfs_txt{'total_submitted'}</div>
        <div style="float: left; width: 10%; text-align: right; padding-top: 2px; padding-bottom: 2px;">$sfs_submitted</div>~;
        }
        $yymain .= qq~
            </td>
        </tr>~;
    }
    $yymain .= qq~
</add before>

<edit file>
Admin/AdminSubList.pm
</edit file>

<search for>
'errorlog' => 'ErrorLog.pm&ErrorLog',
</search for>

<add after>
'clearspamlog' => 'StopForumSpamLog.pm&ClearSpamLog',
</add after>

<search for>
'showclicks' => 'Admin.pm&ShowClickLog',
</search for>

<add after>
'stopforumspam_log' => 'StopForumSpamLog.pm&StopForumSpamLog',
</add after>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $stopforumspam_mod = "StopForumSpam Mod|Derek Barnstorm, updated for 2.6.0 by Dandello|This Mod will allow you to check the StopForumSpam.com database for Usernames, Email addresses and IP Addresses on registration, guest posting, broadcast message, alert moderator and send topic. You can also allow Administrators to submit details to the database when spammers get through who haven't already been submitted.|0.7|4th July, 2014";
    push (@installed_mods, "$stopforumspam_mod");

</add before>

<edit file>
Admin/ModuleChecker.pm
</edit file>

<search for>

foreach my $module ( @modules ) {
</search for>

<add before>
push @modules, 'XML::Simple', 'XML::SAX';
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
\$ML_Allowed = $ML_Allowed;                 # allow browse MemberList
</search for>

<add after>

\$check_sfs_username = $check_sfs_username;          # Set to 1 to check Usernames against the StopForumSpam database
\$check_sfs_ip = $check_sfs_ip;                      # Set to 1 to check IP Addresses against the StopForumSpam database
\$check_sfs_email = $check_sfs_email;                # Set to 1 to check Email Addresses against the StopForumSpam database
\$sfs_ip_ban = $sfs_ip_ban;                          # Set to 1 to Auto-ban IP Addresses if they match those in the StopForumSpam database
\$sfs_email_ban = $sfs_email_ban;                    # Set to 1 to Auto-ban Email Addresses if they match those in the StopForumSpam database
\$sfs_ban_all = $sfs_ban_all;                        # Set to 1 to Auto-ban IP Address and Email Address if either one matches
\$sfs_ip_block = $sfs_ip_block;                      # Set to 1 to block IP Addresses on server level with The Guardian
\$check_sfs_connection = $check_sfs_connection;      # Set to 1 to exit with an error message if the StopForumSpam database is unavailable
\$sfs_connection_timeout = $sfs_connection_timeout;  # Set the StopForumSpam connection timeout in seconds
\$sfs_custom_url = "\Q$sfs_custom_url\E";            # URL to redirect spammers to instead of the registration error message
\$sfs_submit = $sfs_submit;                          # Set to 1 to enable Administrators to submit spammers to the StopForumSpam database
\$sfs_api_key = "\Q$sfs_api_key\E";                  # StopForumSpam API Key
\$sfs_stats = $sfs_stats;                            # Set to 1 to show StopForumSpam Statistics on the Board Index
\$sfs_log = $sfs_log;                                # Set to 1 to enable StopForumSpam registration log
</add after>

<edit file>
Admin/RegistrationLog.pm
</edit file>

<search for>
    $yySetLocation = qq~$adminurl?action=view_reglog~;
    redirectexit();
    return;
}

sub view_registration {
</search for>

<replace>
    if ( !$sfs_response_page) {
        $yySetLocation = qq~$adminurl?action=view_reglog~;
        redirectexit();
    }
    return;
}

sub view_registration {
</replace>

<search for>
    LoadUser($readuser);
</search for>

<add after>
    if ($iamadmin && $sfs_submit && $sfs_api_key) {
        eval { require LWP::UserAgent };
        my $moduleUA = $@;
        if (!$moduleUA) {
            $sfs_username = $readuser;
            $sfs_ip = ${$uid.$readuser}{'lastips'};
            $sfs_email = ${$uid.$readuser}{'email'};
            if ($viewtype eq "validate") {
                $sfs_submit_txt = $prereg_txt{'sfs_delete_report'};
                $sfs_confirm_txt = $prereg_txt{'sfs_delete_confirm'};
            }
            elsif ($viewtype eq 'approve') {
                $sfs_submit_txt = $prereg_txt{'sfs_reject_report'};
                $sfs_confirm_txt = $prereg_txt{'sfs_reject_confirm'};
            }
            $sfs_report = qq~<input type="submit" name="moda" value="$sfs_submit_txt" onclick="return confirm('$sfs_confirm_txt');" class="button" />
    <input type="hidden" name="sfs_username" value="$sfs_username" />
    <input type="hidden" name="sfs_ip" value="$sfs_ip" />
    <input type="hidden" name="sfs_email" value="$sfs_email" />~;
        }
        else {
            $sfs_report = q{};
        }
    }
</add after>

<search for>
            <input type="submit" name="moda" value="$prereg_txt{'apr_admin_approve'}" onclick="return confirm('$prereg_txt{'apr_admin_approve'} ?')" class="button" />
</search for>

<add after>
            $sfs_report
</add after>

<search for>
            <input type="submit" name="moda" value="$prereg_txt{'apr_admin_validate'}" onclick="return confirm('$prereg_txt{'apr_admin_validate'} ?')" class="button" />
</search for>

<add after>
            $sfs_report
</add after>

<search for>
            kill_registration($descuser);
        }
</search for>

<add after>
        elsif ($descision eq $prereg_txt{'sfs_delete_report'}) {
            require Sources::StopForumSpam;
            $sfs_response_page = 1;
            kill_registration($descuser);
            SubmitForumSpam();
        }
</add after>

<search for>
            reject_registration($descuser);
        }
</search for>

<add after>
        elsif ($descision eq $prereg_txt{'sfs_reject_report'}) {
            require Sources::StopForumSpam;
            $sfs_response_page = 1;
            reject_registration($descuser);
            SubmitForumSpam();
        }
</add after>

<search for>
    $yySetLocation = qq~$adminurl?action=view_reglog~;
    redirectexit();
    return;
}

sub approve_registration {
</search for>

<replace>
    if ( !$sfs_response_page) {
        $yySetLocation = qq~$adminurl?action=view_reglog~;
        redirectexit();
    }
    return;
}

sub approve_registration {
</replace>

<edit file>
Admin/Settings_Antispam.pm
</edit file>

<search for>
$bdomains =~ s/,/\n/gxsm;
</search for>

<add after>

# StopForumSpam Mod Start
$sfs_connection_timeout ||= 10;

eval { require LWP::UserAgent };
my $moduleUA = $@;
eval { require XML::Simple };
my $moduleSimple = $@;
eval { require XML::SAX };
my $moduleSAX = $@;

if ($moduleUA || $moduleSimple || $moduleSAX) {
    $sfs_field_display = qq~style="display: none;" ~;
    $sfs_header = qq~<span style="font-weight: bold;">~;
    $sfs_header .= qq~<span class="important">$settings_txt{'stopforumspam_modules'}</span><br />~;
    if ($moduleUA) { $sfs_header .= qq~LWP::UserAgent<br />~; }
    if ($moduleSimple) { $sfs_header .= qq~XML::Simple<br />~; }
    if ($moduleSAX) { $sfs_header .= qq~XML::SAX~; }
    $sfs_header .= q~</span>~;
}
else {
    $sfs_field_display = q{};
    $sfs_header = qq~$settings_txt{'stopforumspam_header'}~;
}
# StopForumSpam Mod End
</add after>

<search for>
                name     => 'bdomains',
                validate => 'fulltext,null',
            },
        ],
    },
</search for>

<add after>
   {
        name  => $settings_txt{'stopforumspam'},
        id    => 'stopforumspam',
        items => [
        {
            header => $sfs_header,
        },
        {
            description => qq~<label for="check_sfs_username">$admin_txt{'sfs_username'}</label>~,
            input_html => qq~<input type="checkbox" name="check_sfs_username" id="check_sfs_username" value="1"${ischecked($check_sfs_username)} $sfs_field_display/>~,
            name => 'check_sfs_username',
            validate => 'boolean',
        },
        {
            description => qq~<label for="check_sfs_ip">$admin_txt{'sfs_ip'}</label>~,
            input_html => qq~<input type="checkbox" name="check_sfs_ip" id="check_sfs_ip" value="1"${ischecked($check_sfs_ip)} $sfs_field_display/>~,
            name => 'check_sfs_ip',
            validate => 'boolean',
        },
        {
            description => qq~<label for="check_sfs_email">$admin_txt{'sfs_email'}</label>~,
            input_html => qq~<input type="checkbox" name="check_sfs_email" id="check_sfs_email" value="1"${ischecked($check_sfs_email)} $sfs_field_display/>~,
            name => 'check_sfs_email',
            validate => 'boolean',
        },
        {
            description => qq~<label for="sfs_ip_ban">$admin_txt{'sfs_ip_ban'}</label>~,
            input_html => qq~<input type="checkbox" name="sfs_ip_ban" id="sfs_ip_ban" value="1"${ischecked($sfs_ip_ban)} $sfs_field_display/>~,
            name => 'sfs_ip_ban',
            validate => 'boolean',
            depends_on => ['check_sfs_ip'],
        },
        {
            description => qq~<label for="sfs_email_ban">$admin_txt{'sfs_email_ban'}</label>~,
            input_html => qq~<input type="checkbox" name="sfs_email_ban" id="sfs_email_ban" value="1"${ischecked($sfs_email_ban)} $sfs_field_display/>~,
            name => 'sfs_email_ban',
            validate => 'boolean',
            depends_on => ['check_sfs_email'],
        },
        {
            description => qq~<label for="sfs_ban_all">$admin_txt{'sfs_ban_all'}</label>~,
            input_html => qq~<input type="checkbox" name="sfs_ban_all" id="sfs_ban_all" value="1"${ischecked($sfs_ban_all)} $sfs_field_display/>~,
            name => 'sfs_ban_all',
            validate => 'boolean',
            depends_on => ['check_sfs_ip', 'check_sfs_email', 'sfs_ip_ban', 'sfs_email_ban'],
        },
        {
            description => qq~<label for="sfs_ip_block">$admin_txt{'sfs_ip_block'}</label>~,
            input_html => qq~<input type="checkbox" name="sfs_ip_block" id="sfs_ip_block" value="1"${ischecked($sfs_ip_block)} $sfs_field_display/>~,
            name => 'sfs_ip_block',
            validate => 'boolean',
            depends_on => ['check_sfs_ip'],
        },
        {
            description => qq~<label for="check_sfs_connection">$admin_txt{'sfs_connection'}</label>~,
            input_html => qq~<input type="checkbox" name="check_sfs_connection" id="check_sfs_connection" value="1"${ischecked($check_sfs_connection)} $sfs_field_display/>~,
            name => 'check_sfs_connection',
            validate => 'boolean',
            depends_on => ['check_sfs_username||', 'check_sfs_ip||', 'check_sfs_email||'],
        },
        {
            description => qq~<label for="sfs_connection_timeout">$admin_txt{'sfs_timeout'}</label>~,
            input_html => qq~<input type="text" name="sfs_connection_timeout" id="sfs_connection_timeout" size="3" value="$sfs_connection_timeout" $sfs_field_display/>~,
            name => 'sfs_connection_timeout',
            validate => 'number',
            depends_on => ['check_sfs_username||', 'check_sfs_ip||', 'check_sfs_email||'],
        },
        {
            description => qq~<label for="sfs_custom_url">$admin_txt{'sfs_custom_url'}</label>~,
            input_html => qq~<input type="text" name="sfs_custom_url" id="sfs_custom_url" size="35" value="$sfs_custom_url" $sfs_field_display/>~,
            name => 'sfs_custom_url',
            validate => 'text,null',
            depends_on => ['check_sfs_username||', 'check_sfs_ip||', 'check_sfs_email||'],
        },
        {
            description => qq~<label for="sfs_submit">$admin_txt{'sfs_submit'}</label>~,
            input_html => qq~<input type="checkbox" name="sfs_submit" id="sfs_submit" value="1"${ischecked($sfs_submit)} $sfs_field_display/>~,
            name => 'sfs_submit',
            validate => 'boolean',
        },
        {
            description => qq~<label for="sfs_api_key">$admin_txt{'sfs_api_key'}</label>~,
            input_html => qq~<input type="text" name="sfs_api_key" id="sfs_api_key" size="35" value="$sfs_api_key" $sfs_field_display/>~,
            name => 'sfs_api_key',
            validate => 'text,null',
            depends_on => ['sfs_submit'],
        },
        {
            description => qq~<label for="sfs_stats">$admin_txt{'sfs_stats'}</label>~,
            input_html => qq~<input type="checkbox" name="sfs_stats" id="sfs_stats" value="1"${ischecked($sfs_stats)} $sfs_field_display/>~,
            name => 'sfs_stats',
            validate => 'boolean',
            depends_on => ['check_sfs_username||', 'check_sfs_ip||', 'check_sfs_email||', 'sfs_submit||'],
        },
        {
            description => qq~<label for="sfs_log">$admin_txt{'sfs_log'}</label>~,
            input_html => qq~<input type="checkbox" name="sfs_log" id="sfs_log" value="1"${ischecked($sfs_log)} $sfs_field_display/>~,
            name => 'sfs_log',
            validate => 'boolean',
            depends_on => ['check_sfs_username||', 'check_sfs_ip||', 'check_sfs_email||'],
        },
    ],
},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
'sfs_username' => 'Check Usernames against the StopForumSpam database?',
'sfs_ip' => 'Check IP Addresses against the StopForumSpam database?',
'sfs_email' => 'Check Email Addresses against the StopForumSpam database?',
'sfs_ip_ban' => 'Auto-ban IP Addresses if they match those in the StopForumSpam database?',
'sfs_email_ban' => 'Auto-ban Email Addresses if they match those in the StopForumSpam database?',
'sfs_ban_all' => 'Auto-ban both IP Address and Email Address if either one matches?',
'sfs_ip_block' => 'Block IP Addresses on server level if they match those in the StopFromSpam database?<br /><span class="small">This feature will only work if your server supports .htaccess files and \'Activate .htaccess to add IP blocks on server level?\' is enabled in The Guardian.</span>',
'sfs_connection' => 'Disallow registration and guest posting if the StopForumSpam database is unavailable?<br /><span class="small">- Check this option to display an error message if the StopForumSpam database is unavailable.<br />- Leave unchecked for no blocking to be done if the StopForumSpam database is unavailable.</span>',
'sfs_timeout' => 'Connection timeout in seconds:<br /><pan class="small">The amount of time before the request to the StopForumSpam database is aborted.</span>',
'sfs_custom_url' => 'Enter a URL here if you would like to redirect spammers to another page or website instead of displaying the default error message:',
'sfs_submit' => 'Enable Administrators to submit spammers to the StopForumSpam database from user profile pages and the registration log?<br /><span class="small">You will need to enter your API key below for this feature to work.</span>',
'sfs_api_key' => 'Your API Key:<br /><span class="small">If you haven\'t got an API key, you can get one from the <a href="http://www.stopforumspam.com" target="_blank">StopForumSpam</a> website.</span>',
'sfs_stats' => 'Enable StopForumSpam Statistics on the Board Index?',
'sfs_log' => 'Enable StopForumSpam Log for registrations?',
</add before>

<search for>
'a8_label5' => 'View Registration Log',
</search for>

<add after>
'a8_sub6' => 'StopForumSpam Log',
'a8_label6' => 'View StopForumSpam Log',
</add after>

<search for>
'LWP::UserAgent' => 'Used by "GoogieSpell", our Spell Checker.<br />If this module is not installed, you cannot enable the Spell Checker. Otherwise you do not need this module.',
</search for>

<replace>
'LWP::UserAgent' => 'Used by "GoogieSpell" (our Spell Checker) and the StopForumSpam checks on registration.<br />If this module is not installed, you cannot enable the Spell Checker or StopForumSpam checks. Otherwise you do not need this module.',
</replace>

<search for>
'Digest::HMAC_MD5' => 'Used to send e-mails via "YaBB SMTP Engine".<br />This module is only needed if you want to send your e-mails via the "YaBB SMTP Engine". Otherwise you do not need this module.',
</search for>

<add after>
'XML::Simple' => 'Used for the StopForumSpam checks on registration.<br />If this module is not installed, you cannot enable the StopForumSpam checks. Otherwise you do not need this module.<br />Note: This module relies on the XML::SAX module listed below.',
'XML::SAX' => 'Used for the StopForumSpam checks on registration.<br />If this module is not installed, you cannot enable the StopForumSpam checks. Otherwise you do not need this module.<br />Note: The XML::Simple module listed above relies on this module.',
</add after>

<search for>
);

#HoneyPot
</search for>

<add before>
'stopforumspam' => 'StopForumSpam',
'stopforumspam_header' => 'These settings allow you to check the <a href="http://www.stopforumspam.com/" target="_blank">StopForumSpam.com</a> database for Usernames, IP Addresses and Email Addresses on registration, guest posting, broadcast message, alert moderator and send topic. If any details match a spammers details in their database then registration or guest posting will not be allowed. You can also allow Administrators to submit details to the database when spammers get through who haven\'t already been submitted (you will need an API Key from their website for the submit feature to work).',
'stopforumspam_modules' => 'The following modules are missing which need to be installed before you can enable these settings:',
</add before>

<edit file>
Languages/English/Error.lng
</edit file>

<search for>
'no_siglinks_allowed'  => "Sorry, you are not allowed to create a signature containing active links to websites or images before you have posted $minlinksig normal messages.",
</search for>

<add after>
'post_spam'              => "Submission not allowed: Your details match those of a known spammer.",
'post_spam_error'        => "Sorry, there was an error submitting the form. This is only a temporary connection error, so please either go back and try again or try again later.",
</add after>

<search for>
'no_reg_reason'        => "Without giving a reason for applying for membership we cannot process your application.",
</search for>

<add after>
'reg_spam'              => "Registration not allowed: Your details match those of a known spammer.",
'reg_spam_error'        => "Sorry, there was an error during the registration process. This is only a temporary connection error, so please either go back and try again or try again later.",
</add after>

<edit file>
Languages/English/Register.lng
</edit file>

<search for>
'apr_admin_delete' => 'Delete Account',
</search for>

<add after>
'sfs_delete_report' => 'Delete and Report to StopForumSpam',
'sfs_reject_report' => 'Reject and Report to StopForumSpam',
'sfs_delete_confirm' => 'Are you sure you want to delete this account and submit the Username, Email Address and IP Address to the StopForumSpam database?',
'sfs_reject_confirm' => 'Are you sure you want to reject this account and submit the Username, Email Address and IP Address to the StopForumSpam database?',
</add after>

<edit file>
Sources/BoardIndex.pm
</edit file>

<search for>
            $botlist = qq~<span class="small">$botlist</span>~;
        }

</search for>

<add after>
    if ($sfs_stats && ($check_sfs_username || $check_sfs_ip || $check_sfs_email || ($sfs_submit && $sfs_api_key))) {
        if (-e "$vardir/sfs_stats.txt") { require "$vardir/sfs_stats.txt"; }
        LoadLanguage('StopForumSpam');
        $sfs_blocked ||= 0;
        $sfs_submitted ||= 0;
        $sfs_blocked = NumberFormat($sfs_blocked);
        $sfs_submitted = NumberFormat($sfs_submitted);
        $sfs_statistics = qq~<b>$sfs_txt{'statistics'}</b><br />~;
        if ($check_sfs_username || $check_sfs_ip || $check_sfs_email) { $sfs_statistics .= qq~$sfs_txt{'total_blocked'} <b>$sfs_blocked</b><br />~; }
        if ($sfs_submit && $sfs_api_key) { $sfs_statistics .= qq~$sfs_txt{'total_submitted'} <b>$sfs_submitted</b>~; }
    }
    else {
        $sfs_statistics = '&nbsp;';
    }

</add after>

<search for>
        $boardindex_template =~ s/{yabb sharedlogin}/$shared_login/gsm;
</search for>

<add after>
        $boardindex_template =~ s/{yabb sfs_statistics}/$sfs_statistics/gsm;
</add after>

<edit file>
Sources/Post.pm
</edit file>

<search for>
            if   ( $spamdetected == 1 ) { fatal_error('tsc_alert'); }
            else                        { fatal_error('speed_alert'); }
        }
    }
</search for>

<add after>
    if ($iamguest && ($check_sfs_username || $check_sfs_ip || $check_sfs_email)) {
        require Sources::StopForumSpam;
        $sfs_username = $name;
        $sfs_email = $email;
        CheckForumSpam();
    }
</add after>

<search for>
        if   ( $spamdetected == 1 ) { fatal_error('tsc_alert'); }
        else                        { fatal_error('speed_alert'); }
    }
</search for>

<add after>
    if ($check_sfs_username || $check_sfs_ip || $check_sfs_email) {
        require Sources::StopForumSpam;
        $sfs_username = $name;
        $sfs_email = $email;
        CheckForumSpam();
    }
</add after>

<search for>
        ## clean name and email - remove | from name and turn any _ to spaces for email
</search for>

<add after>

        if ($iamguest && ($check_sfs_username || $check_sfs_ip || $check_sfs_email)) {
            require Sources::StopForumSpam;
            $sfs_username = $name;
            $sfs_email = $email;
            CheckForumSpam();
        }
</add after>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
                    $ip_ban_options .= qq~$lookupIP<br />$banlink[$i]<br />~;
</search for>

<replace>
                    if ($sfs_submit && $sfs_api_key && $iamadmin && ${ $uid . $user }{'position'} ne 'Global Moderator') {
                        eval { require LWP::UserAgent };
                        my $moduleUA = $@;
                        if (!$moduleUA) {
                            LoadLanguage('StopForumSpam');
                            $sfs_username = $user;
                            $sfs_email = ${$uid.$user}{'email'};
                            $sfs_username =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;
                            $sfs_email =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;
                            $sfs[$i] = qq~<span class="small">[<a href="$scripturl?action=stopforumspam;sfs_username=$sfs_username;sfs_ip=$ip_ban[$i];sfs_email=$sfs_email" title="$sfs_txt{'title'}" style="color: #FF0000;" onclick="return confirm('$sfs_txt{'confirm'}');">$sfs_txt{'report'}</a>]</span><br />~;
                        }
                        else { $sfs[$i] = q{SFS}; }
                    }
                    $ip_ban_options .= qq~$lookupIP<br />$banlink[$i]<br />$sfs[$i]~;
 </replace>

<edit file>
Sources/Register.pm
</edit file>

<search for>
    ToHTML( $member{'language'} );
</search for>

<add before>
    if ($check_sfs_username || $check_sfs_ip || $check_sfs_email) {
        require Sources::StopForumSpam;
        $sfs_username = $member{'regusername'};
        $sfs_email = $member{'email'};
        CheckForumSpam();
    }

</add before>

<edit file>
Sources/SendTopic.pm
</edit file>

<search for>
    if (   ( $remail =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/sm )
        || ( $remail !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/sm ) )
    {
        fatal_error( 'invalid_email', "$sendtopic_txt{'718'}" );
    }
</search for>

<add after>

    if ( $check_sfs_username || $check_sfs_ip || $check_sfs_email ) {
        require Sources::StopForumSpam;
        $sfs_username = $yname;
        $sfs_email = $yemail;
        CheckForumSpam();
    }
</add after>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
'sticky' => 'SetStatus.pm&SetStatus',
</search for>

<add after>
'stopforumspam' => 'StopForumSpam.pm&SubmitForumSpam',
</add after>

<edit file>
Templates/default/BoardIndex.template
</edit file>

<search for>
                    <div class="small" style="float: left; width: 90%; text-align: left;">
                    $boardindex_txt{'800'} <b>{yabb mostusers}</b>$maintxt{'30b'} $maintxt{'30'} {yabb mostusersdate}.<br />
                    $boardindex_txt{'801'} <b>{yabb mostmembers}</b>$maintxt{'30b'} $maintxt{'30'} {yabb mostmembersdate}.<br />
                    $boardindex_txt{'802'} <b>{yabb mostguests}</b>$maintxt{'30b'} $maintxt{'30'} {yabb mostguestsdate}.<br />
                    $boardindex_txt{'803'} <b>{yabb mostbots}</b>$maintxt{'30b'} $maintxt{'30'} {yabb mostbotsdate}.
                    </div>
 </search for>

<replace>
                    <div class="small" style="float: left; width: 60%; text-align: left;">
                    $boardindex_txt{'800'} <b>{yabb mostusers}</b>$maintxt{'30b'} $maintxt{'30'} {yabb mostusersdate}.<br />
                    $boardindex_txt{'801'} <b>{yabb mostmembers}</b>$maintxt{'30b'} $maintxt{'30'} {yabb mostmembersdate}.<br />
                    $boardindex_txt{'802'} <b>{yabb mostguests}</b>$maintxt{'30b'} $maintxt{'30'} {yabb mostguestsdate}.<br />
                    $boardindex_txt{'803'} <b>{yabb mostbots}</b>$maintxt{'30b'} $maintxt{'30'} {yabb mostbotsdate}.
                    </div>
                   <div class="small" style="float: left; width: 40%; text-align: left;">
        {yabb sfs_statistics}
                  </div>
</replace>
