###############################################################################
# StopForumSpam.pm                                                            #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.1                                                  #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2014 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use CGI::Carp qw(fatalsToBrowser);
use English qw(-no_match_vars);
our $VERSION = '2.6.0';

$stopforumspampmver = 'YaBB 2.6.1 $Revision: 0.2 $';
if ( $action eq 'detailedversion' ) { return 1; }

sub CheckForumSpam {

    eval { require LWP::UserAgent };
    my $moduleUA = $EVAL_ERROR;
    eval { require XML::Simple };
    my $moduleSimple = $EVAL_ERROR;
    eval { require XML::SAX };
    my $moduleSAX = $EVAL_ERROR;

    if ( !$moduleUA && !$moduleSimple && !$moduleSAX ) {

        my $ua = LWP::UserAgent->new;
        $ua->timeout($sfs_connection_timeout);

        $sfs_url =
            'http://www.stopforumspam.com/api?username='
          . $sfs_username
          . '&amp;ip='
          . $user_ip
          . '&amp;email='
          . $sfs_email;
        $get_reg_spam = $ua->get($sfs_url);

        if ( $get_reg_spam->is_success ) {
            $xml = XML::Simple->new;
            $spam_user_check = $xml->XMLin( $get_reg_spam->content );
            if (
                (
                       $check_sfs_username
                    && $spam_user_check->{appears}->[0] eq 'yes'
                )
                || (   $check_sfs_ip
                    && $spam_user_check->{appears}->[1] eq 'yes' )
                || (   $check_sfs_email
                    && $spam_user_check->{appears}->[2] eq 'yes' )
              )
            {
                $sfs_ban_ip    = 0;
                $sfs_ban_email = 0;
                if (
                    (
                           $sfs_ip_ban
                        && $check_sfs_ip
                        && $spam_user_check->{appears}->[1] eq 'yes'
                    )
                    || (   $sfs_ip_ban
                        && $check_sfs_ip
                        && $sfs_ban_all
                        && $sfs_email_ban
                        && $check_sfs_email
                        && $spam_user_check->{appears}->[2] eq 'yes' )
                  )
                {
                    $ihave = 0;
                    $tmb   = 0;
                    if ($user_ip) {
                        $type       = 'I';
                        $banned     = $user_ip;
                        $sfs_ban_ip = 1;
                    }
                    elsif (
                        (
                               $sfs_email_ban
                            && check_sfs_email()
                            && $spam_user_check->{appears}->[2] eq 'yes'
                        )
                        || (   $sfs_email_ban
                            && $check_sfs_email
                            && $sfs_ban_all
                            && $sfs_ip_ban
                            && $check_sfs_ip
                            && $spam_user_check->{appears}->[1] eq 'yes' )
                      )
                    {
                        $type          = 'E';
                        $banned        = $sfs_email;
                        $sfs_ban_email = 1;
                    }
                    if ( $sfs_ban_ip || $sfs_ban_email ) {
                        $add_ban = qq~$type|$banned|$time|SFS|p|\n~;
                    }
                    fopen( BAN2, ">>$vardir/banlist.txt" )
                      || fatal_error( 'cannot_open', "$vardir/banlist.txt", 1 );
                    print {BAN2} $add_ban or croak "$croak{'print'} BAN2";
                    fclose(BAN2);
                }
                if (   $use_guardian
                    && $use_htaccess
                    && $sfs_ip_block
                    && $check_sfs_ip
                    && $spam_user_check->{appears}->[1] eq 'yes' )
                {
                    my @ipblock;
                    require Admin::GuardianAdmin;
                    @sfs_access_denied = update_htaccess('load');
                    foreach (@sfs_access_denied) {
                        if ( $_ ne $user_ip ) { push @ipblock, $_; }
                    }
                    push @ipblock, $user_ip;
                    update_htaccess( 'save', @ipblock );
                }
                if ($sfs_custom_url) {
                    ForumSpamStats();
                    print "Location: $sfs_custom_url\n\r\n\r"
                      or croak
                      or croak "$croak{'print'} stats";
                    if ( $action eq 'register2' ) {
                        if ($sfs_log) {
                            $sfs_status = 'blocked';
                            ForumSpamLog();
                        }
                        fatal_error('reg_spam');
                    }
                    else {
                        fatal_error('post_spam');
                    }
                }
                else {
                    ForumSpamStats();
                    if ( $action eq 'register2' ) {
                        if ($sfs_log) {
                            $sfs_status = 'blocked';
                            ForumSpamLog();
                        }
                        fatal_error('reg_spam');
                    }
                    else {
                        fatal_error('post_spam');
                    }
                }
            }
        }
        elsif ($check_sfs_connection) {
            if ( $action eq 'register2' ) {
                if ($sfs_log) {
                    $sfs_status = $get_reg_spam->code;
                    ForumSpamLog();
                }
                fatal_error('reg_spam_error');
            }
            else {
                fatal_error('post_spam_error');
            }
        }
        elsif ( $sfs_log && $action eq 'register2' ) {
            $sfs_status = $get_reg_spam->code;
            ForumSpamLog();
            return;
        }

        if ( $sfs_log && $action eq 'register2' ) {
            $sfs_status = 'ok';
            ForumSpamLog();
        }
    }
    return;
}

sub SubmitForumSpam {

    if (   !$iamadmin
        || !$sfs_submit
        || !$sfs_api_key
        || ( !$INFO{'sfs_username'} && !$FORM{'sfs_username'} ) )
    {
        fatal_error('not_allowed');
    }

    LoadLanguage('StopForumSpam');

    $sfs_username = $INFO{'sfs_username'} || $FORM{'sfs_username'};
    $sfs_ip       = $INFO{'sfs_ip'}       || $FORM{'sfs_ip'};
    $sfs_email    = $INFO{'sfs_email'}    || $FORM{'sfs_email'};

    $username = $sfs_username;
    if ($do_scramble_id) { $username = cloak($sfs_username); }

    if   ( $sfs_username =~ m/s$/sm ) { $apos = q{'}; }
    else                              { $apos = q{'s}; }

    eval { require LWP::UserAgent };
    my $moduleUA = $EVAL_ERROR;

    if ( !$moduleUA ) {

        my $ua = LWP::UserAgent->new;
        $ua->timeout($sfs_connection_timeout);

        $sfs_request = $ua->post(
#            'http://www.stopforumspam.com/post.php',
            'http://www.yabbforumsoftware.com/',
            [
                username => $sfs_username,
                ip_addr  => $sfs_ip,
                email    => $sfs_email,
                api_key  => $sfs_api_key,
            ]
        );
        $sfs_request->content_type('application/x-www-form-urlencoded');

        if ( $sfs_request->code == 200 ) {
            $sfs_response = qq~<p>$sfs_txt{'success'}</p>~;
            $sfs_response .= $sfs_request->content;
            ForumSpamStats();
        }
        elsif ( $sfs_request->code == 403 ) {
            $sfs_response = qq~<p>$sfs_txt{'submit_error'}</p>~;
            $sfs_response .= $sfs_request->content;
        }
        else {
            $sfs_response = qq~<p>$sfs_txt{'connection_error'}</p>~;
        }

        if ( $INFO{'sfs_username'} ) {
            $sfs_return =
qq~<a href="$scripturl?action=viewprofile;username=$username">$sfs_txt{'profile_return1'} $sfs_username$apos $sfs_txt{'profile_return2'}</a>~;
        }
        else {
            $sfs_return =
qq~<a href="$adminurl?action=view_reglog">$sfs_txt{'reglog_return'}</a>~;
        }

    }
    else {
        $sfs_response = qq~<p>$sfs_txt{'module_error'}</p>~;
    }

    $yymain = qq~
<table class="tabtitle cs_thin pad_4px" style="width:500px">
    <tr>
        <th><img src="$yyhtml_root/ModImages/sfs.png" alt="" /> $sfs_txt{'stopforumspam'}</th>
    </tr>
</table>
<table class="bordercolor center cs_thin pad_4px" style="width:500px">
    <tr>
        <td class="windowbg center">
            <p style="font-weight: bold;">$sfs_txt{'response'}</p>
            $sfs_response
            <p>$sfs_return</p>
        </td>
    </tr>
</table>~;

    $yytitle      = qq~$sfs_txt{'stopforumspam'}~;
    $yynavigation = qq~&rsaquo; $sfs_txt{'stopforumspam'}~;
    template();
    return;
}

sub ForumSpamLog {

    fopen( ForumSpamLog, ">>$vardir/stopforumspam.log" );
    print {ForumSpamLog}
      "$date|$sfs_status|$sfs_username|$sfs_email|$user_ip\n"
      or croak "$croak{'print'} log";
    fclose(ForumSpamLog);
    return;

}

sub ForumSpamStats {

    if ( -e "$vardir/sfs_stats.txt" ) { require "$vardir/sfs_stats.txt"; }

    $sfs_blocked   ||= 0;
    $sfs_submitted ||= 0;

    if ( $INFO{'sfs_username'} || $FORM{'sfs_username'} ) { $sfs_submitted++; }
    else                                                  { $sfs_blocked++; }

    fopen( SFSTATS, ">$vardir/sfs_stats.txt" );
    print {SFSTATS} qq~\$sfs_blocked = "$sfs_blocked";\n~
       or croak "$croak{'print'} stats";
    print {SFSTATS} qq~\$sfs_submitted = "$sfs_submitted";\n~
       or croak "$croak{'print'} stats";
    print {SFSTATS} q~1;~ or croak "$croak{'print'} stats";
    fclose(SFSTATS);
    return;
}

1;
